import 'package:boost/boost.dart';
import 'package:cl_datahub_common/common.dart';

String buildQueryString(Map<String, String?> query) {
  if (query.isEmpty) {
    return '';
  }

  String encodeEntry(MapEntry<String, String?> e) {
    final key = Uri.encodeQueryComponent(e.key);
    if (!nullOrEmpty(e.value)) {
      return '$key=${Uri.encodeQueryComponent(e.value!)}';
    } else {
      return key;
    }
  }

  return '?' + query.entries.map(encodeEntry).join('&');
}

final RegExp _plExp = RegExp('(?<!\\\\)\\{([\\w-]*)}');

String replacePlaceholders(String source, Map<String, dynamic> values) {
  return source.replaceAllMapped(_plExp, (match) {
    final key = match.group(1);
    if (key == null) {
      throw ApiException('Invalid placeholder-key: ${match.group(0)}');
    }

    if (values[key] == null) {
      throw ApiException('Missing value in url params: $key');
    }

    return Uri.encodeComponent(values[key].toString());
  });
}
